 include "ti83plus.inc"

_jforcecmdkey	equ	402a

EXT_APP equ 1   ;This definition is required of all apps
cseg            ;This linker directive is required of all apps.  

;*****
;default APP header   80h bytes long
 db 080h,0Fh    ;Field: Program length
 db   00h,00h,00h,00h ;Length=0 (N/A for unsigned apps)
 db 080h,012h    ;Field: Program type
 db   01h,04h  ;Type= Shareware, TI-83Plus
 db 080h,021h    ;Field: App ID
 db   01h       ;Id = 1
 db 080h,031h    ;Field: App Build
 db   01h       ;Build = 1
 db 080h,048h    ;Field: App Name
 db "Grades  " ;Name = "Hello   " must be 8 characters
 db 080h,081h    ;Field: App Pages
 db 01h         ;App Pages = 1
 db 080h,090h    ;No default splash screen
 db 03h,026h ,09h,04h, 04h,06fh,01bh,80h     ;Field: Date stamp- 5/12/1999
 db 02h,0dh,040h                             ;Dummy encrypted TI date stamp signature
 db 0a1h ,06bh ,099h ,0f6h ,059h ,0bch ,067h 
 db 0f5h ,085h ,09ch ,09h ,06ch ,0fh ,0b4h ,03h ,09bh ,0c9h 
 db 03h ,032h ,02ch ,0e0h ,03h ,020h ,0e3h ,02ch ,0f4h ,02dh 
 db 073h ,0b4h ,027h ,0c4h ,0a0h ,072h ,054h ,0b9h ,0eah ,07ch 
 db 03bh ,0aah ,016h ,0f6h ,077h ,083h ,07ah ,0eeh ,01ah ,0d4h 
 db 042h ,04ch ,06bh ,08bh ,013h ,01fh ,0bbh ,093h ,08bh ,0fch 
 db 019h ,01ch ,03ch ,0ech ,04dh ,0e5h ,075h 
 db 80h,7Fh      ;Field: Program Image length
 db   0,0,0,0    ;Length=0, N/A
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved
 db   0,0,0,0    ;Reserved      
;*****

startapp:
	ld	hl,basicprogname
	rst	rMOV9TOOP1
	B_CALL	chkfindsym
	call	nc,delbasicvar			;delete basic program if it exists
	
	ld	hl,basicprogname
	rst	rMOV9TOOP1
	ld	hl,basicend-basicstart		;progsize
	B_CALL	createprotprog			;create protected basic program

	inc	de
	inc	de				;->progs data area in RAM
	ld	bc,basicend-basicstart		;progsize
	ld	hl,basicstart			;->start of basic prog data in ROM
	ldir					;copy prog from rom to ram

	ld	hl,currententryvarname
	rst	rMOV9TOOP1
	B_CALL	chkfindsym
	call	nc,delcurentry			;delete current entry
	
	ld	hl,currententryvarname
	rst	rMOV9TOOP1
	ld	hl,basicstart-basicnameforcurentry	;size of new ! var
	B_CALL	createprog
	
	inc	de
	inc	de				;-> ! var data area
	ld	bc,basicstart-basicnameforcurentry	;num of bytes to copy
	ld	hl,basicnameforcurentry
	ldir					;copy to ! var
	
	ld	a,kenter			;return to homescreen and run basic prog
        B_JUMP  jforcecmdkey

delbasicvar:
	B_CALL	delvararc
	ret

delcurentry:
	B_CALL	delvararc
	ret
        
basicprogname:
	db	protprogobj,"BASGRADE",0

currententryvarname:
	db	progobj,"!",0
	
basicnameforcurentry:
	db	tprog,tB,tA,tS,tG,tR,tA,tD,tE
    
basicstart:
	;clear LCD
	db	tcllcd
	;Input "Total Pts:",A
	db	tenter,tinput,tstring,tT,to,tt,ta,tl,tspace,tP,tt,ts,tcolon,tstring,tcomma,ta
	;100/a->b
	db	tenter,t1,t0,t0,tdiv,ta,tstore,tb
	;disp "Pts off per prob:",round(B,3)
	db	tenter,tdisp,tstring,tp,tt,ts,tspace,to,tf,tf,tspace,tp,te,tr,tspace,tp,tr,to,tb,tstring,tcomma,tround,tb,tcomma,t3,trparen
	;pause
	db	tenter,tpause
	;lbl a
	db	tenter,tlbl,ta
	;clrlcd
	db	tenter,tcllcd
	;input "Total Wrong:",c
	db	tenter,tinput,tstring,tt,to,tt,ta,tl,tspace,tw,tr,to,tn,tg,tcolon,tstring,tcomma,tc
	;100-b*c->d
	db	tenter,t1,t0,t0,tsub,tb,tmul,tc,tstore,td
	;round(d,3)->d
	db	tenter,tround,td,tcomma,t3,trparen,tstore,td
	;disp "Percent Grade:",d
	db	tenter,tdisp,tstring,tp,te,tr,tc,te,tn,tt,tspace,tg,tr,ta,td,te,tcolon,tstring,tcomma,td
	;disp "Letter Grade:"
	db	tenter,tdisp,tstring,tl,te,tt,tt,te,tr,tspace,tg,tr,ta,td,te,tcolon,tstring
	;round(d,0)->d
	db	tenter,tround,td,tcomma,t0,trparen,tstore,td
	;if d>=99:disp "a+"
	db	tenter,tif,td,tge,t9,t9,tcolon,tdisp,tstring,[14]tspace,ta,tadd,tstring
	;if	d>=95 and d<=98:disp "a"
	db	tenter,tif,td,tge,t9,t5,tand,td,tle,t9,t8,tcolon,tdisp,tstring,[15]tspace,ta,tstring
	;if	d>=93 and d<=94:disp "a-"
	db	tenter,tif,td,tge,t9,t3,tand,td,tle,t9,t4,tcolon,tdisp,tstring,[14]tspace,ta,tsub,tstring
	;if	d>=91 and d<=92:disp "b+"
	db	tenter,tif,td,tge,t9,t1,tand,td,tle,t9,t2,tcolon,tdisp,tstring,[14]tspace,tb,tadd,tstring	
	;if	d>=88 and d<=90:disp "b"
	db	tenter,tif,td,tge,t8,t8,tand,td,tle,t9,t0,tcolon,tdisp,tstring,[15]tspace,tb,tstring	
	;if	d>=86 and d<=87:disp "b-"
	db	tenter,tif,td,tge,t8,t6,tand,td,tle,t8,t7,tcolon,tdisp,tstring,[14]tspace,tb,tsub,tstring	
	;if	d>=83and d<=85:disp "c+"
	db	tenter,tif,td,tge,t8,t3,tand,td,tle,t8,t5,tcolon,tdisp,tstring,[14]tspace,tc,tadd,tstring	
	;if	d>=79 and d<=82:disp "c"
	db	tenter,tif,td,tge,t7,t9,tand,td,tle,t8,t2,tcolon,tdisp,tstring,[15]tspace,tc,tstring	
	;if	d>=76 and d<=78:disp "c-"
	db	tenter,tif,td,tge,t7,t6,tand,td,tle,t7,t8,tcolon,tdisp,tstring,[14]tspace,tc,tsub,tstring	
	;if	d>=74 and d<=75:disp "d+"
	db	tenter,tif,td,tge,t7,t4,tand,td,tle,t7,t5,tcolon,tdisp,tstring,[14]tspace,td,tadd,tstring	
	;if	d>=72 and d<=73:disp "d"
	db	tenter,tif,td,tge,t7,t2,tand,td,tle,t7,t3,tcolon,tdisp,tstring,[15]tspace,td,tstring	
	;if	d>=70 and d<=71:disp "d-"
	db	tenter,tif,td,tge,t7,t0,tand,td,tle,t7,t1,tcolon,tdisp,tstring,[14]tspace,td,tsub,tstring	
	;if	d<=69:disp "f"
	db	tenter,tif,td,tle,t6,t9,tcolon,tdisp,tstring,[15]tspace,tf,tstring
	;pause
	db	tenter,tpause
	;goto a
	db	tenter,tgoto,ta	
basicend: